/*------------------------------*/
/*  Intro a la programac de     */
/*  juegos, por Nacho Cabanes   */
/*                              */
/*   ElementoGraf.h:            */
/*     Clase "elemento grfico" */
/*       para Allegro           */
/*     Fichero de cabecera      */
/*                              */
/*     Parte de "MiniMiner"     */
/*                              */
/*  Ejemplo:                    */
/*    Primer acercamiento a     */
/*    "MiniMiner"               */
/*                              */
/*  Comprobado con:             */
/*  - DevC++ 4.9.9.2(gcc 3.4.2) */
/*    y Allegro 4.03 - WinXP    */
/*------------------------------*/

#ifndef ElementoGraf_h
#define ElementoGraf_h

#include <allegro.h>

class ElementoGraf {

 public:

    void moverA(int x, int y);
    void indicarAnchoAlto(int an, int al);
    void crearDesdeFichero(char *nombre);
    BITMAP* leerImagen();
    int leerX();
    int leerY();
    int leerAnchura();
    int leerAltura();

    bool colisionCon(ElementoGraf e2);
    bool colisionCon(int x, int y, int ancho, int alto);

 protected:

    int posX;
    int posY;
    int anchura, altura;
    int anchuraOrig, alturaOrig;
    int colorTransp;

 private:

    BITMAP* imagen;

};
#endif
