/*------------------------------*/
/*  Intro a la programac de     */
/*  juegos, por Nacho Cabanes   */
/*                              */
/*   Hardware.h:                */
/*     Clase "Hardware"         */
/*       para Allegro           */
/*     Fichero de cabecera      */
/*                              */
/*     Parte de "MiniMiner"     */
/*                              */
/*  Ejemplo:                    */
/*    Primer acercamiento a     */
/*    "MiniMiner"               */
/*                              */
/*  Comprobado con:             */
/*  - DevC++ 4.9.9.2(gcc 3.4.2) */
/*    y Allegro 4.03 - WinXP    */
/*------------------------------*/

#ifndef Hardware_h
#define Hardware_h

#include <vector>
#include <string>
using namespace std;

#include <allegro.h>


#include "ElementoGraf.h"

#define TECLA_ESC KEY_ESC
#define TECLA_DCHA KEY_RIGHT
#define TECLA_ARRB KEY_UP
#define TECLA_ABAJ KEY_DOWN
#define TECLA_IZQD KEY_LEFT
#define TECLA_ESPACIO KEY_SPACE
#define TECLA_A KEY_a
#define TECLA_B KEY_b
#define TECLA_C KEY_c
#define TECLA_D KEY_d
#define TECLA_E KEY_e
#define TECLA_F KEY_f
#define TECLA_G KEY_g
#define TECLA_H KEY_h
#define TECLA_I KEY_i
#define TECLA_J KEY_j
#define TECLA_K KEY_k
#define TECLA_L KEY_l
#define TECLA_M KEY_m
#define TECLA_N KEY_n
#define TECLA_O KEY_o
#define TECLA_P KEY_p
#define TECLA_Q KEY_q
#define TECLA_R KEY_r
#define TECLA_S KEY_s
#define TECLA_T KEY_t
#define TECLA_U KEY_u
#define TECLA_V KEY_v
#define TECLA_W KEY_w
#define TECLA_X KEY_x
#define TECLA_Y KEY_y
#define TECLA_Z KEY_z

#define TECLA_0 KEY_0
#define TECLA_1 KEY_1
#define TECLA_2 KEY_2
#define TECLA_3 KEY_3
#define TECLA_4 KEY_4
#define TECLA_5 KEY_5
#define TECLA_6 KEY_6
#define TECLA_7 KEY_7
#define TECLA_8 KEY_8
#define TECLA_9 KEY_9

#define TECLA_F1 KEY_F1

class Hardware {

 public:

    //Hardware();
    void inicializar(int ancho, int alto);
    bool comprobarTecla();

    bool comprobarTecla(int codigoTecla);
    int esperarTecla();
    void vaciarBufferTeclado();
    bool algunaTeclaPulsada();


    void borrarOculta();
    void dibujarOculta(ElementoGraf e);

    void visualizarOculta();

    void pausa(long ms);

 private:

    int anchoPantalla;
    int altoPantalla;

    BITMAP *pantallaOculta;
    int maxX;
    int maxY;
    int colores;
    int teclaPulsada;
    int posXRaton;
    int posYRaton;

 private:

    BITMAP pantallaVisible;
    BITMAP fondo;


};
#endif
