#ifndef NivelJuego_h
#define NivelJuego_h

#include <vector>

#include "Pantalla.h"

#define REBOTEVERTICAL 1
#define REBOTEHORIZONTAL 0

/** NivelJuego: clase que se encarga de dibujar la pantalla
 *  de juego -ladrillos, etc- y de comprobar las
 *  posibles colisiones de la pelota con los ladrillos
 */
class NivelJuego : public Pantalla {

 public:

    NivelJuego();

    virtual void inicializar();

    virtual void leerNivel();

    virtual void dibujar(Hardware h1);

    virtual int comprobarColision(ElementoGraf p);

    virtual bool quedanLadrillos();

 public:
    int marcoXmin;
    int marcoXmax;
    int marcoYmin;
    int marcoYmax;
    int nivelActual;
    //int anguloChoque;
    int tipoRebote; // Vertical u horizontal
    Hardware h;


    ElementoGraf ladrillo, ladrillo2, ladrillo3, ladrillo4,
      ladrillo9;

    struct  {
        int x;
        int y;
        int anchura;
        int altura;
        int tipoLadrillo;
    } datosLadrillos[13][13];


};
#endif
